using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Drawing.Drawing2D;
using System.Drawing.Printing;

namespace MySecondApp
{
	/// <summary>
	/// Summary description for AboutDialog.
	/// </summary>
	public class AboutDialog : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button buttonPrint;
		private System.Windows.Forms.Button buttonPrintPreview;
		private System.Windows.Forms.PrintDialog printDialog1;
		private System.Drawing.Printing.PrintDocument printDocument1;
		private System.Windows.Forms.PrintPreviewDialog printPreviewDialog1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public AboutDialog()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(AboutDialog));
			this.buttonPrint = new System.Windows.Forms.Button();
			this.buttonPrintPreview = new System.Windows.Forms.Button();
			this.printDialog1 = new System.Windows.Forms.PrintDialog();
			this.printDocument1 = new System.Drawing.Printing.PrintDocument();
			this.printPreviewDialog1 = new System.Windows.Forms.PrintPreviewDialog();
			this.SuspendLayout();
			// 
			// buttonPrint
			// 
			this.buttonPrint.Font = new System.Drawing.Font("Microsoft Sans Serif", 8F);
			this.buttonPrint.Location = new System.Drawing.Point(40, 208);
			this.buttonPrint.Name = "buttonPrint";
			this.buttonPrint.Size = new System.Drawing.Size(80, 23);
			this.buttonPrint.TabIndex = 0;
			this.buttonPrint.Text = "Print";
			this.buttonPrint.Click += new System.EventHandler(this.buttonPrint_Click);
			// 
			// buttonPrintPreview
			// 
			this.buttonPrintPreview.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonPrintPreview.Location = new System.Drawing.Point(152, 208);
			this.buttonPrintPreview.Name = "buttonPrintPreview";
			this.buttonPrintPreview.Size = new System.Drawing.Size(80, 23);
			this.buttonPrintPreview.TabIndex = 1;
			this.buttonPrintPreview.Text = "PrintPreview";
			this.buttonPrintPreview.Click += new System.EventHandler(this.buttonPrintPreview_Click);
			// 
			// printDocument1
			// 
			this.printDocument1.PrintPage += new System.Drawing.Printing.PrintPageEventHandler(this.printDocument1_PrintPage);
			// 
			// printPreviewDialog1
			// 
			this.printPreviewDialog1.AutoScrollMargin = new System.Drawing.Size(0, 0);
			this.printPreviewDialog1.AutoScrollMinSize = new System.Drawing.Size(0, 0);
			this.printPreviewDialog1.ClientSize = new System.Drawing.Size(400, 300);
			this.printPreviewDialog1.Enabled = true;
			this.printPreviewDialog1.Icon = ((System.Drawing.Icon)(resources.GetObject("printPreviewDialog1.Icon")));
			this.printPreviewDialog1.Location = new System.Drawing.Point(66, 87);
			this.printPreviewDialog1.MinimumSize = new System.Drawing.Size(375, 250);
			this.printPreviewDialog1.Name = "printPreviewDialog1";
			this.printPreviewDialog1.TransparencyKey = System.Drawing.Color.Empty;
			this.printPreviewDialog1.Visible = false;
			// 
			// AboutDialog
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(12, 34);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.buttonPrintPreview);
			this.Controls.Add(this.buttonPrint);
			this.Font = new System.Drawing.Font("Comic Sans MS", 18F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Name = "AboutDialog";
			this.Text = "AboutDialog";
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.AboutDialog_Paint);
			this.ResumeLayout(false);

		}
		#endregion

		private void AboutDialog_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			OnDraw(e.Graphics);
		}

		private void buttonPrint_Click(object sender, System.EventArgs e)
		{
			printDialog1.Document = printDocument1;
			if (printDialog1.ShowDialog() == DialogResult.OK) 
			{
				printDocument1.Print();
			}
		}

		private void printDocument1_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
		{
			OnDraw(e.Graphics);
		}

		public void OnDraw(Graphics g) 
		{
			//Graphics g = e.Graphics;
			g.SmoothingMode = SmoothingMode.AntiAlias;
			Rectangle rect = this.ClientRectangle;
			int cx = rect.Width;
			int cy = rect.Height;
			float scale = (float) cy / (float) cx;

			using (LinearGradientBrush brush =
					   new LinearGradientBrush( this.ClientRectangle,
					   Color.Empty,
					   Color.Empty,
					   45) )
			{
				ColorBlend blend = new ColorBlend();
				blend.Colors = new Color[] {Color.Red, Color.Green, Color.Blue, Color.Orange};
				blend.Positions = new float[] {0, 0.33f, 0.66f, 1 };
				brush.InterpolationColors = blend;
				using ( Pen pen = new Pen(brush) ) 
				{
					for (int x=0; x < cx; x += 7) 
					{
						g.DrawLine(pen, 0, x * scale, cx - x, 0);
						g.DrawLine(pen, 0, (cx - x) * scale, cx - x, cx * scale);
						g.DrawLine(pen, cx - x, 0, cx, (cx - x) * scale);
						g.DrawLine(pen, cx - x, cx * scale, cx, x * scale);
					}
				}
				StringFormat format = new StringFormat();
				format.Alignment = StringAlignment.Center;
				format.LineAlignment = StringAlignment.Center;
				string str = "Ain't Graphics Cool?";
				g.DrawString(str, this.Font, brush, rect, format);
			}
		}

		private void buttonPrintPreview_Click(object sender, System.EventArgs e)
		{
			printPreviewDialog1.Document = printDocument1;
			printPreviewDialog1.ShowDialog();
		}
	}
}
