using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace MySecondApp
{
	/// <summary>
	/// Summary description for Options.
	/// </summary>
	public class Options : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label labelColor;
		private System.Windows.Forms.Button buttonChange;
		private System.Windows.Forms.Button buttonOK;
		private System.Windows.Forms.Button buttonCancel;
		private System.Windows.Forms.ErrorProvider errorProviderColor;
		private System.Windows.Forms.ColorDialog colorDialog;
        private System.Windows.Forms.Button buttonAbout;
        private Button button2;
        private Button buttonReloadPi;
        private Button buttonSavePI;
        private Label labelPi;
        private TextBox textBoxPI;
        private Label labelHelp;
        private ToolTip toolTipHelp;
        private IContainer components;

		public Options()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
                if (colorDialog != null)
                {
                    colorDialog.Dispose();
                }
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            this.labelColor = new System.Windows.Forms.Label();
            this.buttonChange = new System.Windows.Forms.Button();
            this.buttonOK = new System.Windows.Forms.Button();
            this.buttonCancel = new System.Windows.Forms.Button();
            this.errorProviderColor = new System.Windows.Forms.ErrorProvider(this.components);
            this.colorDialog = new System.Windows.Forms.ColorDialog();
            this.buttonAbout = new System.Windows.Forms.Button();
            this.buttonReloadPi = new System.Windows.Forms.Button();
            this.button2 = new System.Windows.Forms.Button();
            this.buttonSavePI = new System.Windows.Forms.Button();
            this.textBoxPI = new System.Windows.Forms.TextBox();
            this.labelPi = new System.Windows.Forms.Label();
            this.labelHelp = new System.Windows.Forms.Label();
            this.toolTipHelp = new System.Windows.Forms.ToolTip(this.components);
            ((System.ComponentModel.ISupportInitialize)(this.errorProviderColor)).BeginInit();
            this.SuspendLayout();
            // 
            // labelColor
            // 
            this.labelColor.Location = new System.Drawing.Point(40, 48);
            this.labelColor.Name = "labelColor";
            this.labelColor.Size = new System.Drawing.Size(80, 23);
            this.labelColor.TabIndex = 0;
            this.labelColor.Text = "Favorite Color";
            // 
            // buttonChange
            // 
            this.buttonChange.BackColor = System.Drawing.Color.SpringGreen;
            this.buttonChange.Location = new System.Drawing.Point(168, 48);
            this.buttonChange.Name = "buttonChange";
            this.buttonChange.Size = new System.Drawing.Size(75, 23);
            this.buttonChange.TabIndex = 1;
            this.buttonChange.Text = "Change";
            this.toolTipHelp.SetToolTip(this.buttonChange, "Color is set to FavoriteColor property\r\nOpens color dialog that is a member of th" +
                    "e class");
            this.buttonChange.UseVisualStyleBackColor = false;
            this.buttonChange.MouseLeave += new System.EventHandler(this.Generic_MouseLeave);
            this.buttonChange.Click += new System.EventHandler(this.buttonChange_Click);
            this.buttonChange.Validating += new System.ComponentModel.CancelEventHandler(this.buttonChange_Validating);
            this.buttonChange.MouseEnter += new System.EventHandler(this.Generic_MouseEnter);
            // 
            // buttonOK
            // 
            this.buttonOK.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.buttonOK.Location = new System.Drawing.Point(31, 94);
            this.buttonOK.Name = "buttonOK";
            this.buttonOK.Size = new System.Drawing.Size(75, 23);
            this.buttonOK.TabIndex = 2;
            this.buttonOK.Text = "OK";
            this.buttonOK.MouseLeave += new System.EventHandler(this.Generic_MouseLeave);
            this.buttonOK.MouseEnter += new System.EventHandler(this.Generic_MouseEnter);
            // 
            // buttonCancel
            // 
            this.buttonCancel.CausesValidation = false;
            this.buttonCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.buttonCancel.Location = new System.Drawing.Point(111, 94);
            this.buttonCancel.Name = "buttonCancel";
            this.buttonCancel.Size = new System.Drawing.Size(75, 23);
            this.buttonCancel.TabIndex = 3;
            this.buttonCancel.Text = "Cancel";
            this.toolTipHelp.SetToolTip(this.buttonCancel, "CausesValidation is false");
            this.buttonCancel.MouseLeave += new System.EventHandler(this.Generic_MouseLeave);
            this.buttonCancel.Click += new System.EventHandler(this.buttonCancel_Click);
            this.buttonCancel.MouseEnter += new System.EventHandler(this.Generic_MouseEnter);
            // 
            // errorProviderColor
            // 
            this.errorProviderColor.ContainerControl = this;
            // 
            // buttonAbout
            // 
            this.buttonAbout.BackColor = System.Drawing.SystemColors.ControlLight;
            this.buttonAbout.CausesValidation = false;
            this.buttonAbout.Location = new System.Drawing.Point(191, 94);
            this.buttonAbout.Name = "buttonAbout";
            this.buttonAbout.Size = new System.Drawing.Size(75, 23);
            this.buttonAbout.TabIndex = 4;
            this.buttonAbout.Text = "About";
            this.toolTipHelp.SetToolTip(this.buttonAbout, "CausesValidation is false");
            this.buttonAbout.UseVisualStyleBackColor = false;
            this.buttonAbout.MouseLeave += new System.EventHandler(this.Generic_MouseLeave);
            this.buttonAbout.Click += new System.EventHandler(this.buttonAbout_Click);
            this.buttonAbout.MouseEnter += new System.EventHandler(this.Generic_MouseEnter);
            // 
            // buttonReloadPi
            // 
            this.buttonReloadPi.CausesValidation = false;
            this.buttonReloadPi.Location = new System.Drawing.Point(111, 167);
            this.buttonReloadPi.Name = "buttonReloadPi";
            this.buttonReloadPi.Size = new System.Drawing.Size(75, 23);
            this.buttonReloadPi.TabIndex = 8;
            this.buttonReloadPi.Text = "Reload PI";
            this.toolTipHelp.SetToolTip(this.buttonReloadPi, "Set PI to the current value saved in the user settings\r\n");
            this.buttonReloadPi.UseVisualStyleBackColor = true;
            this.buttonReloadPi.MouseLeave += new System.EventHandler(this.Generic_MouseLeave);
            this.buttonReloadPi.Click += new System.EventHandler(this.buttonReloadPi_Click);
            this.buttonReloadPi.MouseEnter += new System.EventHandler(this.Generic_MouseEnter);
            // 
            // button2
            // 
            this.button2.CausesValidation = false;
            this.button2.Location = new System.Drawing.Point(191, 167);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(75, 23);
            this.button2.TabIndex = 9;
            this.button2.Text = "Reset PI";
            this.toolTipHelp.SetToolTip(this.button2, "Set PI to the value stored in the use settings in the application");
            this.button2.UseVisualStyleBackColor = true;
            this.button2.MouseLeave += new System.EventHandler(this.Generic_MouseLeave);
            this.button2.Click += new System.EventHandler(this.button2_Click);
            this.button2.MouseEnter += new System.EventHandler(this.Generic_MouseEnter);
            // 
            // buttonSavePI
            // 
            this.buttonSavePI.CausesValidation = false;
            this.buttonSavePI.Location = new System.Drawing.Point(30, 167);
            this.buttonSavePI.Name = "buttonSavePI";
            this.buttonSavePI.Size = new System.Drawing.Size(75, 23);
            this.buttonSavePI.TabIndex = 10;
            this.buttonSavePI.Text = "Save PI";
            this.toolTipHelp.SetToolTip(this.buttonSavePI, "Save user settings, PI will change to current value in text box\r\nWhen app is rest" +
                    "arted, the new user value of PI will be shown\r\n");
            this.buttonSavePI.UseVisualStyleBackColor = true;
            this.buttonSavePI.MouseLeave += new System.EventHandler(this.Generic_MouseLeave);
            this.buttonSavePI.Click += new System.EventHandler(this.buttonSavePI_Click);
            this.buttonSavePI.MouseEnter += new System.EventHandler(this.Generic_MouseEnter);
            // 
            // textBoxPI
            // 
            this.textBoxPI.AcceptsReturn = true;
            this.textBoxPI.CausesValidation = false;
            this.textBoxPI.Location = new System.Drawing.Point(87, 132);
            this.textBoxPI.Name = "textBoxPI";
            this.textBoxPI.Size = new System.Drawing.Size(131, 20);
            this.textBoxPI.TabIndex = 11;
            this.toolTipHelp.SetToolTip(this.textBoxPI, "When text changes, the current value is saved as user PI");
            this.textBoxPI.TextChanged += new System.EventHandler(this.textBoxPI_TextChanged);
            this.textBoxPI.MouseLeave += new System.EventHandler(this.Generic_MouseLeave);
            this.textBoxPI.MouseEnter += new System.EventHandler(this.Generic_MouseEnter);
            // 
            // labelPi
            // 
            this.labelPi.AutoSize = true;
            this.labelPi.Location = new System.Drawing.Point(64, 135);
            this.labelPi.Name = "labelPi";
            this.labelPi.Size = new System.Drawing.Size(17, 13);
            this.labelPi.TabIndex = 12;
            this.labelPi.Text = "PI";
            // 
            // labelHelp
            // 
            this.labelHelp.Location = new System.Drawing.Point(31, 205);
            this.labelHelp.Name = "labelHelp";
            this.labelHelp.Size = new System.Drawing.Size(235, 169);
            this.labelHelp.TabIndex = 13;
            this.labelHelp.MouseLeave += new System.EventHandler(this.Generic_MouseLeave);
            this.labelHelp.MouseEnter += new System.EventHandler(this.Generic_MouseEnter);
            // 
            // Options
            // 
            this.AcceptButton = this.buttonOK;
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.CancelButton = this.buttonCancel;
            this.ClientSize = new System.Drawing.Size(292, 399);
            this.Controls.Add(this.labelHelp);
            this.Controls.Add(this.labelPi);
            this.Controls.Add(this.textBoxPI);
            this.Controls.Add(this.buttonSavePI);
            this.Controls.Add(this.button2);
            this.Controls.Add(this.buttonReloadPi);
            this.Controls.Add(this.buttonAbout);
            this.Controls.Add(this.buttonCancel);
            this.Controls.Add(this.buttonOK);
            this.Controls.Add(this.buttonChange);
            this.Controls.Add(this.labelColor);
            this.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.Name = "Options";
            this.Text = "Options";
            this.toolTipHelp.SetToolTip(this, "ColorDialog is a member variable and must be disposed\r\nFavoriteColor property enc" +
                    "apsulates ColorDialog.Color\r\n");
            this.Load += new System.EventHandler(this.Options_Load);
            this.MouseEnter += new System.EventHandler(this.Generic_MouseEnter);
            this.MouseLeave += new System.EventHandler(this.Generic_MouseLeave);
            ((System.ComponentModel.ISupportInitialize)(this.errorProviderColor)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		private Color favoriteColor;

		private void buttonChange_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			byte greenness = buttonChange.BackColor.G;
			string err="";
			if(greenness < Color.LightGreen.G) 
			{
				err = "I'm sorry, we were going for more green...";
				e.Cancel = true;
			}
			errorProviderColor.SetError(buttonChange, err);
		}

		private void buttonChange_Click(object sender, System.EventArgs e)
		{
			errorProviderColor.SetError(buttonChange, "");
			if (colorDialog.ShowDialog() == DialogResult.OK) 
			{
                //FavoriteColor encapsulates dcolorDialog.Color
				buttonChange.BackColor = FavoriteColor;
			}
		}

		private void Options_Load(object sender, System.EventArgs e)
		{
			buttonChange.BackColor = FavoriteColor;
            SetPI();
		}

        private void SetPI()
        {
            textBoxPI.Text = Convert.ToString(Properties.Settings.Default.Pi);
        }

		private void buttonAbout_Click(object sender, System.EventArgs e)
		{
			new AboutDialog().ShowDialog();
		}

		private void buttonCancel_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		public Color FavoriteColor
		{
			get
			{
				return colorDialog.Color;
			}
			set
			{
				colorDialog.Color = value;
			}
		}

        private void buttonSavePI_Click(object sender, EventArgs e)
        {
            //Set value of PI in user.config file
            Properties.Settings.Default.Save();
        }

        private void buttonReloadPi_Click(object sender, EventArgs e)
        {
            //Set PI to current value in user settings
            Properties.Settings.Default.Reload();
            SetPI();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            //Set PI to original value in application settings
            Properties.Settings.Default.Reset();
            SetPI();
        }

        private void textBoxPI_TextChanged(object sender, EventArgs e)
        {
            Properties.Settings.Default.Pi = Convert.ToDouble(textBoxPI.Text);
        }

        private void Generic_MouseEnter(object sender, EventArgs e)
        {
            labelHelp.Text = toolTipHelp.GetToolTip(((Control)sender));
            toolTipHelp.SetToolTip(((Control)sender), "");
        }

        private void Generic_MouseLeave(object sender, EventArgs e)
        {
            toolTipHelp.SetToolTip(((Control)sender), labelHelp.Text);
            labelHelp.Text = "";
        }
	}
}
